library AppInfo;

uses
  Windows, SysUtils, Variants,
  ExaPlugin_TLB in 'ExaPlugin_TLB.pas';

{$R *.res}

type
  TPlugin = class(TInterfacedObject, IUnknown, IExaDataBaseCommandsPlugin)
  protected
    function Get_CommandCount: Integer; stdcall;
    function Get_Caption(Command: Integer): WideString; stdcall;
    procedure Execute(Command: Integer; const ExaApp: IExaApp); stdcall;
  end;

{ TPlugin }

procedure TPlugin.Execute(Command: Integer; const ExaApp: IExaApp);
var
  LMessage, LUserID: string;
  LUsers: IExaTable;
begin
  //   
  LMessage := Format(': %s', [ExaApp.Get_Name]);
  LMessage := LMessage + sLineBreak + Format(' : %s', [ExaApp.Get_Version]);

  //    
  LUsers := ExaApp.Get_DataBase.TableByName('Users');
  LUserID := ExaApp.Get_User.Get_ID;
  if not LUsers.UserHasReadAccess then
    LMessage := LMessage + sLineBreak + '      '
  else
    if not LUsers.Locate(LUserID) then
      LMessage := LMessage + sLineBreak + Format(' %s     ', [LUserID])
    else
      if not LUsers.UserHasRecordReadAccess(LUserID) then
        LMessage := LMessage + sLineBreak + Format('        %s', [LUserID])
      else begin
        LMessage := LMessage + sLineBreak + Format(' : %s', [VarToStr(LUsers.Get_Values(LUserID, 'NAME'))]);
        LMessage := LMessage + sLineBreak + Format(' : %s', [VarToStr(LUsers.Get_Values(LUserID, 'LOGIN'))]);
      end;

  //  
  Windows.MessageBox(ExaApp.Get_MainFormHandle, PChar(LMessage), '  ', MB_OK);
end;

function TPlugin.Get_Caption(Command: Integer): WideString;
begin
  Result := '  ';
end;

function TPlugin.Get_CommandCount: Integer;
begin
  Result := 1;
end;

{ mixed }

function Init: IInterface; safecall;
begin
  Result := TPlugin.Create;
end;

exports
  Init;

end.
