library Modules;

uses
  Windows, SysUtils, Classes, Variants,
  ExaPlugin_TLB in 'ExaPlugin_TLB.pas';

{$R *.res}

type
  TPlugin = class(TInterfacedObject, IUnknown, IExaDataBaseCommandsPlugin)
  protected
    function Get_CommandCount: Integer; stdcall;
    function Get_Caption(Command: Integer): WideString; stdcall;
    procedure Execute(Command: Integer; const ExaApp: IExaApp); stdcall;
  end;

{ TPlugin }

procedure TPlugin.Execute(Command: Integer; const ExaApp: IExaApp);
var
  LDataBase: IExaDataBase;
  LEnabled, LDisabled, LText: string;
  LModule: IExaModule;
  I: Integer;
begin
  LDataBase := ExaApp.Get_DataBase;
  LEnabled := '';
  LDisabled := '';
  //          
  for I := 0 to LDataBase.Get_ModuleCount - 1 do
  begin
    LModule := LDataBase.Get_Modules(I);
    if LModule.Get_Enabled then
      LEnabled := LEnabled + LModule.Get_Caption + sLineBreak
    else
      LDisabled := LDisabled + LModule.Get_Caption + sLineBreak;
  end;
  if LEnabled = '' then
    LEnabled := '()' + sLineBreak;
  if LDisabled = '' then
    LDisabled := '()' + sLineBreak;
  LText :=
    ':' + sLineBreak + sLineBreak + LEnabled + sLineBreak + sLineBreak +
    ':' + sLineBreak + sLineBreak + LDisabled;
  //  
  Windows.MessageBox(ExaApp.Get_MainFormHandle, PChar(LText), '', MB_OK);
end;

function TPlugin.Get_Caption(Command: Integer): WideString;
begin
  Result := '';
end;

function TPlugin.Get_CommandCount: Integer;
begin
  Result := 1;
end;

{ mixed }

function Init: IInterface; safecall;
begin
  Result := TPlugin.Create;
end;

exports
  Init;

end.
