unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ComCtrls, ExaPlugin_TLB;

type
  TForm1 = class(TForm)
    lvTables: TListView;
    lvFields: TListView;
    spl1: TSplitter;
    procedure lvTablesChange(Sender: TObject; Item: TListItem; Change: TItemChange);
  private
    FDataBase: IExaDataBase;
  public
    procedure Fill(ADataBase: IExaDataBase);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Fill(ADataBase: IExaDataBase);
var
  I: Integer;
  LTable: IExaTable;
  LItem: TListItem;
begin
  FDataBase := ADataBase;
  try
    lvTables.Items.BeginUpdate;
    try
      lvTables.Items.Clear;
      for I := 0 to FDataBase.Get_TableCount - 1 do
      begin
        LTable := FDataBase.Get_Tables(I);
        LItem := lvTables.Items.Add;
        LItem.Caption := LTable.Get_TableName;
        LItem.SubItems.Add(LTable.Get_TableCaption);
        LItem.SubItems.Add(LTable.Get_TableDescription);
        LItem.Data := Pointer(I);
      end;
    finally
      lvTables.Items.EndUpdate;
    end;
  except
    Application.HandleException(Self);
  end;
  lvTablesChange(nil, nil, ctState);
end;

procedure TForm1.lvTablesChange(Sender: TObject; Item: TListItem; Change: TItemChange);
var
  I: Integer;
  LTable: IExaTable;
  LField: IExaField;
  LItem: TListItem;
begin
  try
    lvFields.Items.BeginUpdate;
    try
      lvFields.Items.Clear;
      if lvTables.Selected <> nil then
      begin
        LTable := FDataBase.Get_Tables(Integer(lvTables.Selected.Data));
        for I := 0 to LTable.Get_FieldCount - 1 do
        begin
          LField := LTable.Get_Fields(I);
          LItem := lvFields.Items.Add;
          LItem.Caption := LField.Get_Name;
          LItem.SubItems.Add(LField.Get_Caption);
          LItem.SubItems.Add(LField.Get_Description);
        end;
      end;
    finally
      lvFields.Items.EndUpdate;
    end;
  except
    Application.HandleException(Self);
  end;
end;

end.
